*X390 EXEC X390 SET FLAG(NORENT)
         TITLE 'SMFEXTR - BATCH PROGRAM TO EXTRACT SMF RECORDS'
***********************************************************************
*                                                                     *
* (C) COPYRIGHT DTS SOFTWARE, INC. 1991, 1991 LICENSED MATERIAL -     *
*               PROPERTY OF DTS SOFTWARE, INC.                        *
*                                                                     *
*     CSECT: SMFEXTR                                                  *
*                                                                     *
*     PROGRAMMER: TOM WILLIAMSON              AUG 1, 1993             *
*                 STEVE PRYOR                 MAY 5, 2008             *
*                                                                     *
*     FUNCTION: THIS ROUTINE READS TYPE 4 OR TYPE 30 SMF RECORDS      *
*               AND BUILDS A FLAT FILE FOR EXPORTING TO A PC.         *
*               TYPE 42 RECORDS ARE ALSO READ TO PROVIDE ADDITIONAL   *
*               INFO TO SYSUT2. AN 'EXCLUDE LIST' OF UP TO 10         *
*               JOBNAMES CAN BE SUPPLIED IN THE //EXCLUDE DD.         *
*               THE JOBNAME MUST BE IN THE FIRST 8 POSITIONS,         *
*               LEFT-JUSTIFIED, BLANK-PADDED.                         *
*                                                                     *
***********************************************************************
         SPACE 4
*
*   EQUATES AND GLOBAL SET SYMBOLS USED BY DTS SOFTWARE PRODUCTS
*
$EQUATES DSECT
R0       EQU   0
R1       EQU   1
R2       EQU   2
R3       EQU   3
R4       EQU   4
R5       EQU   5
R6       EQU   6
R7       EQU   7
R8       EQU   8
R9       EQU   9
R10      EQU   10
R11      EQU   11
R12      EQU   12
R13      EQU   13
R14      EQU   14
R15      EQU   15
         EJECT
         MACRO
&LABEL   CVCHAR &S,&D
&LABEL   L     R1,&S
         CVD   R1,DOUBLE
         UNPK  &D,DOUBLE
         OI    &D+L'&D-1,X'F0'
         MEND
         EJECT
*
*  PERFORM STANDARD LINKAGE
*
SMFEXTR  CSECT
SMFEXTR  AMODE 24
SMFEXTR  RMODE 24
         USING SMFEXTR,R15
         B     $STREXTR
         DC    17F'0'
         DC    AL2($STREXTR-*)
         DC    CL24'SMFEXTR &SYSDATE &SYSTIME '
         DC    50X'00'
$STREXTR DS    0H
         DROP  R15
         STM   R14,R12,12(R13)
         ST    R15,8(,R13)
         ST    R13,4(,R15)
         LR    R13,R15
         LA    R11,4095(,R13)
         LA    R11,1(,R11)
         USING SMFEXTR,R13,R11
*
*  OPEN FILES
*
         OPEN  (SMFFILE,INPUT,SYSOUT,OUTPUT,SYSPRINT,OUTPUT)
         OPEN  (SYSPRIN2,OUTPUT)
         TM    SYSPRIN2+X'30',X'10'     ANY SYSPRIN2 PRESENT?
         BNO   NOPRIN2                  IF NOT->
         PUT   SYSPRIN2,RR2H1           WRITE HEADER
         PUT   SYSPRIN2,BLANKS          PRINT BLANK LINE
         PUT   SYSPRIN2,RR2H2           WRITE HEADER
         PUT   SYSPRIN2,BLANKS          PRINT BLANK LINE
NOPRIN2  DS    0H

         OPEN  (EXCLUDE,(INPUT))
         TM    EXCLUDE+X'30',X'10'      EXCLUDE OPEN OK?
         BNO   NOEXCL                   IF NOT->
         LA    R10,EXCLUDES             POINT TO EXCLUDE LIST
         LA    R4,EXCLUDEN              NO. OF POSSIBLE EXCLUDES
INLOOP   DS    0H
         GET   EXCLUDE                  GET A EXCLUDE RECORD
         MVC   0(8,R10),0(R1)           SAVE THE JOBNAME
         LA    R10,8(,R10)              NEXT ENTRY IN EXCLUDE LIST
         BCT   R4,INLOOP                AND CONTINUE READING EXCLUDE
NOEXCL   DS   0H
         EJECT
*
*  READ AN SMF RECORD
*
RLOOP    GET   SMFFILE                  READ SMF RECORD
         LR    R9,R1                    POINT TO RECORD
         USING SMF4LEN,R9
         CLI   SMF4RTY,42               TYPE 42?
         BE    TYPE42                   IF SO-->
         CLI   SMF4RTY,4                TYPE 4?
         BE    TYPE4                    YES
         CLI   SMF4RTY,30               TYPE 30?
         BE    TYPE30                   YES
         B     RLOOP                    READ NEXT RECORD
         EJECT
*
*  PROCESS TYPE 42 RECORD
*
TYPE42   DS    0H
         DROP  R9
         USING SMF42BAS,R9
         CLC   SMF42STY,=X'0009'        SUBTYPE 9 (X37?)
         BNE   RLOOP                    IF NOT->
         LA    R14,SMF42END             POINT TO END OF BASE
         A     R9,SMF42ABO-SMF42S9(,R14) OFFSET TO SUBT 9 SECTION
         USING S42ASYID,R9
         MVC   RR2ASYID,S42ASYID        SYSTEM ID
         MVC   RR2JOBN,S42JOBN          JOBNAME
         MVC   JOBNAME,S42JOBN          SAVE JOBNAME TO TEST EXCLUDES
         BAS   R3,EXCLTEST              SEE IF WE SHOULD EXCLUDE
         MVC   RR2DSN,S42DSNME          DATASET NAME
         MVC   RR2CODEC,=CL4'B37 '      ABEND CODE
         TM    S42FLAGS,S42B37          WAS IT B37?
         BO    GOTCOD                   IF SO->
         MVC   RR2CODEC,=CL4'D37 '      ABEND CODE
         TM    S42FLAGS,S42D37          WAS IT D37?
         BO    GOTCOD                   IF SO->
         MVC   RR2CODEC,=CL4'E37 '      ABEND CODE
         TM    S42FLAGS,S42E37          WAS IT E37?
         BO    GOTCOD                   IF SO->
         MVC   RR2CODEC,=CL4'UNK '      ABEND CODE
GOTCOD   DS    0H

         MVC   RR2VOLSR,S42VOLSR        VOLSER

         SLR   R0,R0
         IC    R0,S42NEXT               NO. OF EXTENTS CUR VOL
         CVD   R0,DOUBLE
         UNPK  RR2NEXT,DOUBLE+5(3)
         OI    RR2NEXT+L'RR2NEXT-1,X'F0'

         MVI   RDRD,X'20'               SET TO Y2K
         MVC   JDUMY,MSAJMASK           MOVE IN EDIT MASK
         ED    JDUMY,RDRD               CONVERT DATE TO CHARACTER
         MVC   RR2DRD,JDATE             MOVE JULIAN DATE TO TMD

         L     R1,S42RDST               GET READER TIME
         BAL   R3,CNVTIME               GO CONVERT TIME
         MVC   RR2DRH,WRKH              MOVE HOUR TO PRINT LINE
         MVC   RR2DRM,WRKM              MOVE MIN  TO PRINT LINE
         MVC   RR2DRS,WRKS              MOVE SEC  TO PRINT LINE

         TM    SYSPRIN2+X'30',X'10'     ANY SYSPRIN2 PRESENT?
         BNO   NOPRIN2                  IF NOT->
         PUT   SYSPRIN2,RREC2
         B     RLOOP                    READ NEXT RECORD
*
*  PROCESS TYPE 4 RECORD
*
         USING SMF4LEN,R9
TYPE4    DS    0H
         MVC   CODE,SMF4SCC             ABEND CODE
         MVC   RDRT,SMF4RST             READER TIME
         MVC   RDRD,SMF4RSD             READER DATE
         MVC   STPT,SMF4SIT             STEP TIME
         MVC   STPD,SMF4STID            STEP DATE
         MVC   ASYSID,SMF4SID           SYSTEM ID
         MVC   RSYSID,SMF4SID           SYSTEM ID
         MVC   AJOBN,SMF4JBN            JOB NAME
         MVC   RJOBN,SMF4JBN            JOB NAME
         MVC   JOBNAME,SMF4JBN          SAVE JOBNAME TO TEST EXCLUDES
         BAS   R3,EXCLTEST              SEE IF WE SHOULD EXCLUDE
         MVC   ABENDT,SMF4TME           EVENT TIME
         MVC   ABENDD,SMF4DTE           EVENT DATE
         MVC   APGMN,SMF4PGMN           PROGRAM NAME
         MVC   RPGMN,SMF4PGMN           PROGRAM NAME
         MVC   ASTEPN,SMF4STMN          STEP NAME
         MVC   RSTEPN,SMF4STMN          STEP NAME
         SR    R8,R8                    ZERO R2
         ICM   R8,B'0011',SMF4LENN      GET LENGTH OF DEVICE ENTRY
         LA    R8,SMF4LENN(R8)          POINT TO ACCOUNTING SEC
         USING SMF4LNTH,R8
         SR    R1,R1                    ZERO R1
         ICM   R1,B'0111',SMF4SETM      CPU TIME
         ST    R1,CPUT                  SAVE CPU TIME
         B     COMMON                   GO TO COMMON SECTION
         EJECT
*
*  PROCESS TYPE 30 RECORD
*
         USING SMF30LEN,R9
TYPE30   DS    0H
         CLC   SMF30STP,=AL2(4)         STEP TOTAL?
         BNE   RLOOP                    NO
         L     R8,SMF30IOF              OFFSET TO IDENT SEC
         AR    R8,R9                    POINT TO SECTION
         USING SMF30JBN,R8
         L     R7,SMF30TOF              OFFSET TO COMP SEC
         AR    R7,R9                    POINT TO SECTION
         USING SMF30SCC,R7
         L     R6,SMF30COF              OFFSET TO PROCESSOR SEC
         AR    R6,R9                    POINT TO SECTION
         USING SMF30PTY,R6
         MVC   RDRT,SMF30RST            READER TIME
         MVC   RDRD,SMF30RSD            READER DATE
         MVC   STPT,SMF30SIT            STEP TIME
         MVC   STPD,SMF30STD            STEP DATE
         MVC   ASYSID,SMF30SID          SYSTEM ID
         MVC   RSYSID,SMF30SID          SYSTEM ID
         MVC   AJOBN,SMF30JBN           JOB NAME
         MVC   RJOBN,SMF30JBN           JOB NAME
         MVC   JOBNAME,SMF30JBN         SAVE JOBNAME TO TEST EXCLUDES
         BAS   R3,EXCLTEST              SEE IF WE SHOULD EXCLUDE
         MVC   ABENDT,SMF30TME          EVENT TIME
         MVC   ABENDD,SMF30DTE          EVENT DATE
         MVC   CODE,SMF30SCC            COMP CODE
         MVC   APGMN,SMF30PGM           PROGRAM NAME
         MVC   RPGMN,SMF30PGM           PROGRAM NAME
         MVC   ASTEPN,SMF30STM          STEP NAME
         MVC   RSTEPN,SMF30STM          STEP NAME
         MVC   CPUT,SMF30CPT            STEP CPU TIME
         EJECT
*
*  REFORMAT THE RECORD AND WRITE TO SYSOUT
*
COMMON   DS    0H
         MVC   ACODEC,=CL4'B37'         SET ABEND CODE
         MVC   RCODEC,=CL4'SB37'        SET ABEND CODE
         CLC   CODE,=AL2(X'B37')        RIGHT ABEND?
         BE    CCODE                    YES
         MVC   ACODEC,=CL4'D37'         SET ABEND CODE
         MVC   RCODEC,=CL4'SD37'        SET ABEND CODE
         CLC   CODE,=AL2(X'D37')        RIGHT ABEND?
         BE    CCODE                    YES
         MVC   ACODEC,=CL4'E37'         SET ABEND CODE
         MVC   RCODEC,=CL4'SE37'        SET ABEND CODE
         CLC   CODE,=AL2(X'E37')        RIGHT ABEND?
         BNE   RLOOP                    NO
CCODE    DS    0H
         CVCHAR RDRT,ARDRT
         CVCHAR CPUT,ACPUT
         CVCHAR ABENDT,AABENDT
         MVC   RCPUTHS,ACPUT+8          MOVE CPU HSEC TO RPTLINE
         MVC   RCPUTS,=C'0'             MOVE ZERO TO CPU SEC
         MVC   RCPUTM,=C'0'             MOVE ZERO TO CPU MIN
         MVC   RCPUTH,=C'0'             MOVE ZERO TO CPU HRS
         CLC   ACPUT(8),=C'0'           ZERO CPU SEC?
         BE    CHKDATE                  YES
         CLC   ACPUT+5(3),=C'059'       MORE THAN 60 SECS?
         BNH   MOVESEC                  NO
         CLC   ACPUT+4(4),=C'3599'      MORE THAN 60 MINS?
         BH    CNVHOUR                  YES
CNVHOUR  DS    0H
MOVESEC  DS    0H
         MVC   RCPUTS,ACPUT+6           MOVE CPU HSEC TO RPTLINE
CHKDATE  DS    0H
         CLC   FRDRD,RDRD               EARLIEST DATE?
         BNH   CHKLAST                  NO
         MVC   FRDRD,RDRD               SAVE FROM DATE
CHKLAST  DS    0H
         CLC   TRDRD,RDRD               LATEST DATE?
         BNL   CNVDATE                  NO
         MVC   TRDRD,RDRD               SAVE TO DATE
CNVDATE  DS    0H
         CLI   RDRD,X'01'               Y2K INDICATOR?
         MVI   RDRD,X'19'               ASSUME 1900S
         BNE   *+8                        NO, CENTURY OKAY
         MVI   RDRD,X'20'                 YES, SET TO Y2K
         MVC   JDUMY,MSAJMASK           MOVE IN EDIT MASK
         ED    JDUMY,RDRD               CONVERT DATE TO CHARACTER
         MVC   ARDRD,JDATE              MOVE JULIAN DATE TO TMD
         MVC   RRDRD,JDATE              MOVE JULIAN DATE TO TMD
         PUT   SYSOUT,AREC              WRITE RECORD
         CLC   TREC,AREC                DUPLICATE RECORD?
         BE    RLOOP                    YES, BYPASS
         MVC   TREC,AREC                SAVE RECORD IN TEMP AREA
         CLC   CODE,=AL2(X'D37')        D37 ABEND?
         BE    AD37                     YES
         CLC   CODE,=AL2(X'E37')        E37 ABEND?
         BE    AE37
         L     R1,NB37                  GET NUM ABENDS
         LA    R1,1(,R1)                ADD ONE
         ST    R1,NB37                  SAVE NUM ABENDS
         B     PRTREPT                  GO PRINT REPORT
AE37     DS    0H
         L     R1,NE37                  GET NUM ABENDS
         LA    R1,1(,R1)                ADD ONE
         ST    R1,NE37                  SAVE NUM ABENDS
         B     PRTREPT                  GO PRINT REPORT
AD37     DS    0H
         L     R1,ND37                  GET NUM ABENDS
         LA    R1,1(,R1)                ADD ONE
         ST    R1,ND37                  SAVE NUM ABENDS
PRTREPT  DS    0H
         L     R1,RDRT                  GET READER TIME
         BAL   R3,CNVTIME               GO CONVERT TIME
         MVC   RRDRH,WRKH               MOVE HOUR TO PRINT LINE
         MVC   RRDRM,WRKM               MOVE MIN  TO PRINT LINE
         MVC   RRDRS,WRKS               MOVE SEC  TO PRINT LINE
         L     R1,ABENDT                GET ABENDT TIME
         BAL   R3,CNVTIME               GO CONVERT TIME
         MVC   RABENDH,WRKH             MOVE HOUR TO PRINT LINE
         MVC   RABENDM,WRKM             MOVE MIN TO PRINT LINE
         MVC   RABENDS,WRKS             MOVE SEC TO PRINT LINE
         CLI   HDRFLG,X'00'             PRINT HEADER?
         BNE   RPTLINE                  NO
         MVI   HDRFLG,X'80'             SET HDR FLAG
         PUT   SYSPRINT,HDR1            PRINT HDR1
         PUT   SYSPRINT,BLANKS          PRINT BLANK LINE
         PUT   SYSPRINT,HDR2            PRINT HDR2
         PUT   SYSPRINT,BLANKS          PRINT BLANK LINE
RPTLINE  DS    0H
         PUT   SYSPRINT,RREC            WRITE REPORT RECORD
         L     R1,NABENDS               GET NUM ABENDS
         LA    R1,1(,R1)                ADD ONE
         ST    R1,NABENDS               SAVE NUM ABENDS
         L     R1,TCPUT                 GET TOT CPU TIME
         A     R1,CPUT                  ADD STEP CPU TIME
         ST    R1,TCPUT                 SAVE TOT CPU TIME
         CLC   ABENDD,STPD              SAME DAY
         BE    SAMEDAY                  YES
         L     R1,STPT                  GET STEP START TIME
         A     R1,=F'240000'            ADD 24 HRS
         ST    R1,STPT                  SAVE NEW TIME
SAMEDAY  DS    0H
         L     R1,ABENDT                GET ABEND TIME
         S     R1,STPT                  SUB STEP START TIME
         L     R2,TSTPT                 GET TOT STEP TIME
         AR    R2,R1                    ADD CURRENT STEP TIME
         ST    R2,TSTPT                 SAVE TOT STEP TIME
         B     RLOOP                    READ NEXT RECORD
         EJECT
CNVTIME  DS    0H
         SR    R0,R0                    CLEAR REG
         D     R0,=F'360000'            CONVERT HOUR
         CVD   R1,DOUBLE                MAKE DECIMAL
         UNPK  WRKH,DOUBLE              MAKE PRINTABLE
         OI    WRKH+L'WRKH-1,X'F0'      MAKE PRINTABLE
         LR    R1,R0                    GET MINUTES
         SR    R0,R0                    CLEAR REG
         D     R0,=F'6000'              CONVERT MIN
         CVD   R1,DOUBLE                MAKE DECIMAL
         UNPK  WRKM,DOUBLE              MAKE PRINTABLE
         OI    WRKM+L'WRKM-1,X'F0'      MAKE PRINTABLE
         LR    R1,R0                    GET SECONDS
         SR    R0,R0                    CLEAR REG
         D     R0,=F'100'               CONVERT SEC
         CVD   R1,DOUBLE                MAKE DECIMAL
         UNPK  WRKS,DOUBLE              MAKE PRINTABLE
         OI    WRKS+L'WRKS-1,X'F0'      MAKE PRINTABLE
         BR    R3                       RETURN
         EJECT
EOF      DS    0H
         PUT   SYSPRINT,SUM1            PRINT SUM1
         PUT   SYSPRINT,BLANKS          PRINT BLANK LINE
         CLC   NABENDS,=F'0'            ANY DETAIL RECORDS?
         BNE   PRTSUMRY                 YES
         PUT   SYSPRINT,SUMNONE         PRINT SUMNONE
         B     CLOSEF                   END
PRTSUMRY DS    0H
         CLI   FRDRD,X'01'              Y2K INDICATOR?
         MVI   FRDRD,X'19'              ASSUME 1900S
         BNE   *+8                        NO, CENTURY OKAY
         MVI   FRDRD,X'20'      ,         YES, SET TO Y2K
         L     R1,FRDRD                 GET BEG READER DATE
         MVC   JDUMY,MSAJMASK           MOVE IN EDIT MASK
         ED    JDUMY,FRDRD              CONVERT DATE TO CHARACTER
         MVC   SFDATE,JDATE             MOVE JULIAN DATE TO TMD
         CLI   TRDRD,X'01'              Y2K INDICATOR?
         MVI   TRDRD,X'19'              ASSUME 1900S
         BNE   *+8                        NO, CENTURY OKAY
         MVI   TRDRD,X'20'      ,         YES, SET TO Y2K
         L     R1,TRDRD                 GET END READER DATE
         MVC   JDUMY,MSAJMASK           MOVE IN EDIT MASK
         ED    JDUMY,TRDRD              CONVERT DATE TO CHARACTER
         MVC   STDATE,JDATE             MOVE JULIAN DATE TO TMD
         PUT   SYSPRINT,SUM2            PRINT SUM2
         PUT   SYSPRINT,BLANKS          PRINT BLANK LINE
         SP    TRDRD,FRDRD              GET # OF DAYS
         CP    TRDRD,=P'365'            CROSS YEAR BOUNDRY?
         BNH   *+10
         SP    TRDRD,=P'635'            ADJUST TO PREV YEAR
         AP    TRDRD,=P'1'              ADD 1 DAY
         MVC   SDAYS,EDPATT             MAKE PRINTABLE
         ED    SDAYS,TRDRD+1            PRINT DAYS
         PUT   SYSPRINT,SUM3            PRINT SUM3
         PUT   SYSPRINT,BLANKS          PRINT BLANK LINE
         L     R15,NABENDS              GET NUM ABENDS
         CVD   R15,DOUBLE               MAKE DECIMAL
         MVC   SABEND,EDPATT            MOVE PATTERN
         ED    SABEND(6),DOUBLE+5       MAKE PRINTABLE
         PUT   SYSPRINT,SREC1           PRINT SREC1
         L     R15,ND37                 GET NUM ABENDS
         CVD   R15,DOUBLE               MAKE DECIMAL
         MVC   SD37,EDPATT              MOVE PATTERN
         ED    SD37(6),DOUBLE+5         MAKE PRINTABLE
         PUT   SYSPRINT,SREC1A          PRINT SREC1
         L     R15,NE37                 GET NUM ABENDS
         CVD   R15,DOUBLE               MAKE DECIMAL
         MVC   SE37,EDPATT              MOVE PATTERN
         ED    SE37(6),DOUBLE+5         MAKE PRINTABLE
         PUT   SYSPRINT,SREC1B          PRINT SREC1
         L     R15,NB37                 GET NUM ABENDS
         CVD   R15,DOUBLE               MAKE DECIMAL
         MVC   SB37,EDPATT              MOVE PATTERN
         ED    SB37(6),DOUBLE+5         MAKE PRINTABLE
         PUT   SYSPRINT,SREC1C          PRINT SREC1
         L     R1,TSTPT                 GET TOT STP TIME
         BAL   R3,CNVTIME               GO CONVERT TIME
         MVC   SSTIMEH,WRKH             MOVE HOUR TO PRINT LINE
         MVC   SSTIMEM,WRKM             MOVE MIN  TO PRINT LINE
         MVC   SSTIMES,WRKS             MOVE SEC  TO PRINT LINE
         PUT   SYSPRINT,SREC2           PRINT SREC2
         CVCHAR TCPUT,ACPUT             CONVERT CPU TIME
         MVC   SCPUTHS,ACPUT+8          MOVE CPU HSEC TO RPTLINE
         MVC   SCPUTS,=C'0'             MOVE ZERO TO CPU SEC
         MVC   SCPUTM,=C'0'             MOVE ZERO TO CPU MIN
         MVC   SCPUTH,=C'0'             MOVE ZERO TO CPU HRS
         CLC   ACPUT(8),=C'0'           ZERO CPU SEC?
         BE    PRTSREC3
         MVC   SCPUTS,ACPUT+6           MOVE CPU SEC TO RPTLINE
PRTSREC3 DS    0H
         PUT   SYSPRINT,SREC3           PRINT SREC3
CLOSEF   DS    0H
         CLOSE (SMFFILE,,SYSOUT,,SYSPRINT)
         CLOSE (SYSPRIN2)
         TM    EXCLUDE+X'30',X'10'      EXCLUDE DD OPEN?
         BNO   QUIT                     IF NOT->
         CLOSE (EXCLUDE)
         SPACE 3
QUIT     DS    0H
         L     R12,4(,R13)
         LA    R14,0
         ST    R14,16(,R12)
         L     R13,4(R13)
         LM    R14,R12,12(R13)
         BR    R14
*
* EXCLUDE THIS RECORD IF JOB NAME IS IN THE EXCLUDE LIST
*
EXCLTEST DS    0H
         LA    R10,EXCLUDES             START OF EXCLUDE LIST
         LA    R4,EXCLUDEN              NO. OF POSSIBLE EXCLUDES
EXCLLOOP DS    0H
         CLC   JOBNAME,0(R10)           MATCH?
         BE    RLOOP                    IF SO->SKIP THIS RECORD
         LA    R10,8(,R10)              NEXT ENTRY IN EXCLUDE LIST
         BCT   R4,EXCLLOOP              UNTIL EXCLUDE LIST DONE
         BR    R3                       RETURN TO CALLER
         EJECT
*
*  STATIC SECTION
*
AREC     DS    0D                       OUTPUT RECORD
ASYSID   DS    CL4                      SYSID
ARDRD    DS    CL8                      READER DATE
ARDRT    DS    CL10                     READER TIME
AJOBN    DS    CL8                      JOBNAME
ASTEPN   DS    CL8                      STEP NAME
APGMN    DS    CL8                      PGMNAME
ACPUT    DS    CL10                     CPU TIME
AABENDT  DS    CL10                     ABEND TIME
ACODEC   DS    CL4                      CODE CHARACTER
ARECLEN  EQU   *-AREC                   LENGTH OF RECORD
         SPACE 3
TREC     DS    CL56                     TEMP RECORD
*REC     DS    CL(ARECLEN)              TEMP RECORD
         SPACE 3
RR2H1    DC    CL121' '                 HEADER LINE 1
         ORG   RR2H1
         DC    C'-     DTS  SOFTWARE, INC.    - '
         DC    C'SPACE ABEND ANALYSIS VER 5.1 - '
         DC    C'TYPE 42 REPORT'
         ORG
         SPACE 3
RR2H2    DC    CL121' '                 HEADER LINE 2
         ORG   RR2H2
         DC    C'0SYS  JOBNAME  DATE     TIME      CODE DSNAME '
         DC    C'                                          VOLSER'
         DC    C' EXTENTS'                                 VOLSER'
         ORG
         SPACE 3
HDR1     DC    CL121' '                 HEADER LINE 1
         ORG   HDR1
         DC    C'-     DTS  SOFTWARE, INC.    - '
         DC    C'SPACE ABEND ANALYSIS VER 5.1 - '
         DC    C'DETAIL REPORT'
         ORG
         SPACE 3
HDR2     DC    CL121' '                 HEADER LINE 2
         ORG   HDR2
         DC    C'0JOBNAME    DATE     TIME    STEPNAME PGMNAME '
*                 MONATST1 10/03/94 10:03:56  STEP0001 IEFBR14X
         DC    C' SYSID  CPU TIME  ABEND TIME  CODE'
*                 SYSA  0:00:03.19  10:03:57   SD37
         ORG
         SPACE 3
SUM1     DC    CL121' '                 SUMMARY LINE 1
         ORG   SUM1
         DC    C'1     DTS  SOFTWARE, INC.    - '
         DC    C'SPACE ABEND ANALYSIS VER 5.1 - '
         DC    C'SUMMARY REPORT'
         ORG
         SPACE 3
SUMNONE  DC    CL121' '                 SUMMARY LINE NONE
         ORG   SUMNONE
         DC    C'      * *  NO B,D,E37 ABEND RECORDS FOUND  * *'
         ORG
         SPACE 3
SUM2     DC    CL121' '                 SUMMARY LINE 2
         ORG   SUM2
         DC    C'   REPORTING PERIOD FROM:  '
SFDATE   DS    CL8
         DC    C' TO: '
STDATE   DS    CL8
         ORG
         SPACE 3
SUM3     DC    CL121' '                 SUMMARY LINE 3
         ORG   SUM3
         DC    C'   REPORTING PERIOD REPRESENTS '
SDAYS    DS    CL6
         DC    C' DAYS'
         ORG
         SPACE 3
SUM4     DC    CL121' '                 SUMMARY LINE 4
         ORG   SUM4
         DC    C'   * * C O S T   A N A L Y S I S * *'
         ORG
         SPACE 3
SUM5     DC    CL121' '                 SUMMARY LINE 5
         ORG   SUM5
         DC    CL10' '
         DC    C'PERSONNEL HOURLY COST     : '
SPHC     DS    CL6
         ORG
         SPACE 3
SUM6     DC    CL121' '                 SUMMARY LINE 6
         ORG   SUM6
         DC    CL10' '
         DC    C'PERSONNEL TIME PER ABEND  : '
SPTA     DS    CL6
         ORG
         SPACE 3
SUM7     DC    CL121' '                 SUMMARY LINE 7
         ORG   SUM7
         DC    CL10' '
         DC    C'CPU HOURLY COST           : '
SCHC     DS    CL6
         ORG
         SPACE 3
SUM8     DC    CL121' '                 SUMMARY LINE 8
         ORG   SUM8
         DC    C'   COST FOR PERIOD'
         ORG
         SPACE 3
SUM9     DC    CL121' '                 SUMMARY LINE 9
         ORG   SUM9
         DC    CL10' '
         DC    C'PERSONNEL COST LOST  : '
         ORG
         SPACE 3
SUM10    DC    CL121' '                 SUMMARY LINE 10
         ORG   SUM10
         DC    CL10' '
         DC    C'CPU COST LOST        : '
         ORG
         SPACE 3
SREC1    DS    0D                       SUMMARY RECORD 1
         DC    CL1'0'                   CC
         DC    CL5' '                   SPACE
         DC    C'TOTAL ABENDS:               '
SABEND   DS    CL6                      TOTAL ABENDS
         DC    CL100' '                 SPACE
         SPACE 3
SREC1A   DS    0D                       SUMMARY RECORD 1
         DC    CL14' '                  SPACE
         DC    C'D37 :     '
SD37     DS    CL6                      TOTAL ABENDS
         DC    CL100' '                 SPACE
         SPACE 3
SREC1B   DS    0D                       SUMMARY RECORD 1
         DC    CL14' '                  SPACE
         DC    C'E37 :     '
SE37     DS    CL6                      TOTAL ABENDS
         DC    CL100' '                 SPACE
         SPACE 3
SREC1C   DS    0D                       SUMMARY RECORD 1
         DC    CL14' '                  SPACE
         DC    C'B37 :     '
SB37     DS    CL6                      TOTAL ABENDS
         DC    CL100' '                 SPACE
         SPACE 3
SREC2    DS    0D                       SUMMARY RECORD 2
         DC    CL1'0'                   CC
         DC    CL5' '                   SPACE
         DC    C'TOTAL TIME LOST (STEP):   '
SSTIMEH  DS    CL2                      TOTAL STEP HOURS
         DC    C':'
SSTIMEM  DS    CL2                      TOTAL STEP MIN
         DC    C':'
SSTIMES  DS    CL2                      TOTAL STEP SEC
         DC    CL100' '                 SPACE
         SPACE 3
SREC3    DS    0D                       SUMMARY RECORD 3
         DC    CL1'0'                   CC
         DC    CL5' '                   SPACE
         DC    C'TOTAL CPU TIME LOST:    '
SCPUTH   DS    CL1                      CPU HOUR
         DC    CL1':'                   DELIM
SCPUTM   DS    CL2                      CPU MIN
         DC    CL1':'                   DELIM
SCPUTS   DS    CL2                      CPU SEC
         DC    CL1'.'                   DELIM
SCPUTHS  DS    CL2                      CPU HSEC
         DC    CL100' '                 SPACE
         SPACE 3
RREC2    DS    0D                       REPORT RECORD
         DC    CL1' '                   SPACE
RR2ASYID DS    CL4                      SYSTEM ID
         DC    CL1' '                   SPACE
RR2JOBN  DS    CL8                      JOBNAME
         DC    CL1' '                   SPACE
RR2DRD   DS    CL8                      READER DATE
         DC    CL1' '                   SPACE
RR2DRH   DS    CL2                      READER HOUR
         DC    CL1':'                   DELIM
RR2DRM   DS    CL2                      READER MINUTE
         DC    CL1':'                   DELIM
RR2DRS   DS    CL2                      READER SECOND
         DC    CL2' '                   SPACE
RR2CODEC DS    CL4                      ABEND CODE
         DC    CL1' '                   SPACE
RR2DSN   DS    CL44                     DSNAME
         DC    CL1' '                   SPACE
RR2DISP  DS    CL3                      DISPOSITION
         DC    CL1' '                   SPACE
RR2VOLSR DS    CL6                      VOLSER
         DC    CL1' '                   SPACE
RR2NEXT  DS    CL8                      NO. OF EXTENTS
         DC    CL1' '                   SPACE
         DC    CL100' '                 SPARE


RREC     DS    0D                       REPORT RECORD
         DC    CL1' '                   SPACE
RJOBN    DS    CL8                      JOBNAME
         DC    CL1' '                   SPACE
RRDRD    DS    CL8                      READER DATE
         DC    CL1' '                   SPACE
RRDRH    DS    CL2                      READER HOUR
         DC    CL1':'                   DELIM
RRDRM    DS    CL2                      READER MINUTE
         DC    CL1':'                   DELIM
RRDRS    DS    CL2                      READER SECOND
         DC    CL2' '                   SPACE
RSTEPN   DS    CL8                      STEP NAME
         DC    CL1' '                   SPACE
RPGMN    DS    CL8                      PGMNAME
         DC    CL1' '                   SPACE
RSYSID   DS    CL4                      SYSID
         DC    CL2' '                   SPACE
RCPUTH   DS    CL1                      CPU HOUR
         DC    CL1':'                   DELIM
RCPUTM   DS    CL2                      CPU MIN
         DC    CL1':'                   DELIM
RCPUTS   DS    CL2                      CPU SEC
         DC    CL1'.'                   DELIM
RCPUTHS  DS    CL2                      CPU HSEC
         DC    CL2' '                   SPACE
RABENDH  DS    CL2                      ABEND HOUR
         DC    CL1':'                   DELIM
RABENDM  DS    CL2                      ABEND MINUTE
         DC    CL1':'                   DELIM
RABENDS  DS    CL2                      ABEND SECOND
         DC    CL3' '                   SPACE
RCODEC   DS    CL4                      CODE CHARACTER
         DC    CL41' '                  SPACES
RRECLEN  EQU   *-RREC                   LENGTH OF RECORD
DOUBLE   DS    D                        DOUBLE WORD
FRDRD    DC    F'99999999'              PERIOD FROM DATE
TRDRD    DC    F'0'                     PERIOD TO DATE
NABENDS  DC    F'0'                     NUM ABENDS
ND37     DC    F'0'                     NUM ABENDS
NE37     DC    F'0'                     NUM ABENDS
NB37     DC    F'0'                     NUM ABENDS
TCPUT    DC    F'0'                     TOT CPU TIME
TSTPT    DC    F'0'                     TOT CPU TIME
RDRD     DS    F                        READER DATE
RDRT     DS    F                        READER TIME
STPD     DS    F                        STEP   DATE
STPT     DS    F                        STEP   TIME
CPUT     DS    F                        CPU STEP TIME
ABENDT   DS    F                        ABEND TIME
ABENDD   DS    F                        ABEND DATE
CODE     DS    H                        ABEND CODE (INTERNAL)
WRKH     DS    CL2                      HOUR
WRKM     DS    CL2                      MINUTE
WRKS     DS    CL2                      SECOND
JDUMY    DS    0CL9                     JULIAN DATE MASK
         DS    CL1
JDATE    DS    CL8
MSAJMASK DC    C' ',X'2120',X'2020',C'.',X'202020'
EDPATT   DC    XL6'402020202120'
BLANKS   DC    CL121' '
HDRFLG   DC    X'00'
JOBNAME  DC    CL8' '                   CURRENT JOBNAME
EXCLUDES DC    10CL8' '                 EXCLUDE LIST
EXCLUDEN EQU   (*-EXCLUDES)/8           NO. OF EXCLUDES
         SPACE 4
SMFFILE  DCB   DSORG=PS,EODAD=EOF,DDNAME=SMFFILE,MACRF=GL,BFTEK=A
SYSOUT   DCB   DSORG=PS,DDNAME=SYSOUT,MACRF=PM,LRECL=ARECLEN,RECFM=FB, +
               BLKSIZE=ARECLEN*10
SYSPRINT DCB   DDNAME=SYSPRINT,MACRF=PM,LRECL=121,RECFM=FBA,DSORG=PS
SYSPRIN2 DCB   DDNAME=SYSPRIN2,MACRF=PM,LRECL=121,RECFM=FBA,DSORG=PS
EXCLUDE  DCB   DDNAME=EXCLUDE,MACRF=GL,LRECL=80,RECFM=FB,DSORG=PS,     +
               EODAD=NOEXCL
         SPACE 4
         LTORG
         EJECT
*
*  DSECTS
*
         IFASMFR (4,30)
         IGWSMF  SMF42_09=YES
         END
